/*
 * $Id: sample1.c,v 1.4 2001/12/31 17:53:57 mcooper Exp $
 *
 * Sample of how to use the mcsysinfoc(3) API.
 *
 * Compile with:
 *
 *	cc -I$sysinfo/include sample1.c -o sample1 -L$sysinfo/lib -lm
 *
 * where $sysinfo is the directory where SysInfo is installed.
 */

#include "mcsysinfo.h"

char *ProgramName = "test1";

main()
{
    int s;
    char **pp = NULL;
    static MCSIquery_t Query;

    (void) memset(&Query, CNULL, sizeof(Query));
    Query.Cmd = MCSI_HOSTNAME;
    s = mcSysInfo(&Query);
    if (s == 0)
	printf ("Hostname is <%s>\n", (char *) Query.Out);
    else
	printf ("gethostname failed\n");

    (void) memset(&Query, CNULL, sizeof(Query));
    Query.Cmd = MCSI_HOSTALIASES;
    s = mcSysInfo(&Query);
    if (s == 0) {
	printf ("Host Aliases =");
	for (pp = (char **) Query.Out; pp && *pp && **pp; ++pp)
	    printf (" %s", *pp);
	printf ("\n");
    }

    (void) memset(&Query, CNULL, sizeof(Query));
    Query.Cmd = MCSI_HOSTADDRS;
    s = mcSysInfo(&Query);
    if (s == 0) {
	printf ("Host Addresses =");
	for (pp = (char **) Query.Out; pp && *pp && **pp; ++pp)
	    printf (" %s", *pp);
	printf ("\n");
    }
}
