/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.3 $
 *
 * SoftFile definetions
 */

#ifndef __mcsoftfile_h__
#define __mcsoftfile_h__ 

/*
 * Software File Data
 */
struct _SoftFileData {
    int			Type;			/* File, dir, symlink, etc */
    char	       *Path;			/* Path to file */
    char	       *LinkTo;			/* Link To what */
    Large_t		FileSize;		/* Size of file */
    char	       *MD5;			/* MD5 checksum */
    char	       *CheckSum;		/* Platform specific checksum */
    char	      **PkgNames;		/* List of used by Pkgs */
    struct _SoftFileData *Next;			/* Next entry */
};
typedef struct _SoftFileData SoftFileData_t;

/*
 * List of SoftFileData_t entries
 */
struct _SoftFileList {
    SoftFileData_t     *FileData;		/* Ptr to FileData entry */
    struct _SoftFileList *Next;			/* Next entry in our list */
};
typedef struct _SoftFileList SoftFileList_t;

/*
 * SoftFile Types for SoftFileData.Type
 */
#define SFT_FILE	1			/* Plain file */
#define SFT_FILE_S	"File"
#define SFT_HLINK	2			/* Hard Link */
#define SFT_HLINK_S	"Hard-Link"
#define SFT_SLINK	3			/* Soft Link */
#define SFT_SLINK_S	"Symbolic-Link"
#define SFT_DIR		4			/* Directory */
#define SFT_DIR_S	"Directory"
#define SFT_CDEV	5			/* Device File */
#define SFT_CDEV_S	"Character-Device"
#define SFT_BDEV	6			/* Device File */
#define SFT_BDEV_S	"Block-Device"

#endif	/* __mcsoftfile_h__ */
