#
# $Id: mcCacheInfo.pm,v 1.4 2002/03/28 23:41:36 mcooper Exp $
#
# CacheInfo object
#

package mcCacheInfo;
require 5.003;

use mcMisc;

#
# Every object value must have a description
#
my $Descriptions =
	{
	 'Name'			=> {Desc=>'Cache Name'},
	 'Enabled'		=> {Desc=>'Enabled'},
	 'Type' 		=> {Desc=>'Type'},
	 'Level' 		=> {Desc=>'Level'},
	 'Size' 		=> {Desc=>'Cache Size'},
	 'Speed' 		=> {Desc=>'Speed (ns)'},
	 'Assoc' 		=> {Desc=>'Associativety'},
	 'Lines' 		=> {Desc=>'# Lines'},
	 'LineSize' 		=> {Desc=>'Line Size'},
	 'TLB' 			=> {Desc=>'# TLB Entries'},
	 'TLBAssoc'	 	=> {Desc=>'# TLB Associativety'},
	 'Socketed'	 	=> {Desc=>'Is cache socketed'},
	 'Location' 		=> {Desc=>'Location relative to CPU'},
	 'SramType' 		=> {Desc=>'SRAM Type'},
	 'EccType' 		=> {Desc=>'ECC Type'},
	 'Mode' 		=> {Desc=>'Mode'},
	 'Device'		=> {NoShow=>1},
	};

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Name"} = undef;
    $self->{"Device"} = undef;
    $self->{"Enabled"} = undef;
    $self->{"Type"} = undef;
    $self->{"Level"} = undef;
    $self->{"Size"} = undef;
    $self->{"Speed"} = undef;
    $self->{"Assoc"} = undef;
    $self->{"Lines"} = undef;
    $self->{"LineSize"} = undef;
    $self->{"TLB"} = undef;
    $self->{"TLBAssoc"} = undef;
    $self->{"Socketed"} = undef;
    $self->{"Location"} = undef;
    $self->{"SramType"} = undef;
    $self->{"EccType"} = undef;
    $self->{"Mode"} = undef;

    $self->{"Desc"} = undef;

    bless ($self, $class);

    return $self;
}

sub Name {
    my $self = shift;

    if (!@_) {
	return $self->{"Name"};
    }

    $self->{"Name"} = shift;

    return;
}

sub Enabled {
    my $self = shift;

    if (!@_) {
	return $self->{"Enabled"};
    }

    $self->{"Enabled"} = shift;

    return;
}

sub Device {
    my $self = shift;

    if (!@_) {
	return $self->{"Device"};
    }

    $self->{"Device"} = shift;

    return;
}

sub Type {
    my $self = shift;

    if (!@_) {
	return $self->{"Type"};
    }

    $self->{"Type"} = shift;

    return;
}

sub Level {
    my $self = shift;

    if (!@_) {
	return $self->{"Level"};
    }

    $self->{"Level"} = shift;

    return;
}

sub Size {
    my $self = shift;

    if (!@_) {
	return $self->{"Size"};
    }

    $self->{"Size"} = shift;

    return;
}

sub Assoc {
    my $self = shift;

    if (!@_) {
	return $self->{"Assoc"};
    }

    $self->{"Assoc"} = shift;

    return;
}

sub Speed {
    my $self = shift;

    if (!@_) {
	return $self->{"Speed"};
    }

    $self->{"Speed"} = shift;

    return;
}

sub Lines {
    my $self = shift;

    if (!@_) {
	return $self->{"Lines"};
    }

    $self->{"Lines"} = shift;

    return;
}

sub LineSize {
    my $self = shift;

    if (!@_) {
	return $self->{"LineSize"};
    }

    $self->{"LineSize"} = shift;

    return;
}

sub TLB {
    my $self = shift;

    if (!@_) {
	return $self->{"TLB"};
    }

    $self->{"TLB"} = shift;

    return;
}

sub TLBAssoc {
    my $self = shift;

    if (!@_) {
	return $self->{"TLBAssoc"};
    }

    $self->{"TLBAssoc"} = shift;

    return;
}

sub Socketed {
    my $self = shift;

    if (!@_) {
	return $self->{"Socketed"};
    }

    $self->{"Socketed"} = shift;

    return;
}

sub Location {
    my $self = shift;

    if (!@_) {
	return $self->{"Location"};
    }

    $self->{"Location"} = shift;

    return;
}

sub SramType {
    my $self = shift;

    if (!@_) {
	return $self->{"SramType"};
    }

    $self->{"SramType"} = shift;

    return;
}

sub EccType {
    my $self = shift;

    if (!@_) {
	return $self->{"EccType"};
    }

    $self->{"EccType"} = shift;

    return;
}

sub Mode {
    my $self = shift;

    if (!@_) {
	return $self->{"Mode"};
    }

    $self->{"Mode"} = shift;

    return;
}

#
# Fetch description
#
sub Desc {
    my $self = shift;
    my $Key = shift;
    my $Desc = $Descriptions->{$Key}->{'Desc'};

    if ($Descriptions->{$Key}->{'NoShow'} || !length($Desc)) {
	return;
    }

    #
    # Include the cache name in the description to help identify which
    # cache type this entry describes.
    #
    return $self->Name . ' ' . $Desc;
}

#
# Decode CacheInfo_t entry
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    $self->Device($Fields[2]);
    $self->Name($Fields[3]);
    $self->Size($Fields[4]);
    $self->Assoc($Fields[5]);
    $self->Lines($Fields[6]);
    $self->LineSize($Fields[7]);
    $self->TLB($Fields[8]);
    $self->TLBAssoc($Fields[9]);
    $self->Enabled($Fields[10]);
    $self->Type($Fields[11]);
    $self->Level($Fields[12]);
    $self->Speed($Fields[13]);
    $self->Socketed($Fields[14]);
    $self->Location($Fields[15]);
    $self->SramType($Fields[16]);
    $self->EccType($Fields[17]);
    $self->Mode($Fields[18]);

    return $self;
}

1;
