#
# $Id: mcNetIf.pm,v 1.1 2001/06/15 19:01:13 mcooper Exp $
#
# NetIf object
#

package mcNetIf;
require 5.003;

use mcMisc;

#
# Every object value must have a description
#
my $Descriptions =
	{
	 'Type'		=> {Desc=>'NIC Address Type'},
	 'HostAddr'	=> {Desc=>'NIC Host Address'},
	 'HostName'	=> {Desc=>'NIC Host Name'},
	 'MACaddr'	=> {Desc=>'NIC MAC Current Address'},
	 'MACname'	=> {Desc=>'NIC MAC Current Name'},
	 'FacMACaddr'	=> {Desc=>'NIC MAC Factory Address'},
	 'FacMACname'	=> {Desc=>'NIC MAC Factory Name'},
	 'NetAddr'	=> {Desc=>'NIC Network Address'},
	 'NetName'	=> {Desc=>'NIC Network Name'},
	};

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Type"} = undef;
    $self->{"HostAddr"} = undef;
    $self->{"HostName"} = undef;
    $self->{"MACaddr"} = undef;
    $self->{"MACname"} = undef;
    $self->{"FacMACaddr"} = undef;
    $self->{"FacMACname"} = undef;
    $self->{"NetAddr"} = undef;
    $self->{"NetName"} = undef;

    $self->{"Desc"} = undef;

    bless ($self, $class);

    return $self;
}

sub Type {
    my $self = shift;

    if (!@_) {
	return $self->{"Type"};
    }

    $self->{"Type"} = shift;

    return;
}

sub HostAddr {
    my $self = shift;

    if (!@_) {
	return $self->{"HostAddr"};
    }

    $self->{"HostAddr"} = shift;

    return;
}

sub HostName {
    my $self = shift;

    if (!@_) {
	return $self->{"HostName"};
    }

    $self->{"HostName"} = shift;

    return;
}

sub MACaddr {
    my $self = shift;

    if (!@_) {
	return $self->{"MACaddr"};
    }

    $self->{"MACaddr"} = shift;

    return;
}

sub MACname {
    my $self = shift;

    if (!@_) {
	return $self->{"MACname"};
    }

    $self->{"MACname"} = shift;

    return;
}

sub FacMACaddr {
    my $self = shift;

    if (!@_) {
	return $self->{"FacMACaddr"};
    }

    $self->{"FacMACaddr"} = shift;

    return;
}

sub FacMACname {
    my $self = shift;

    if (!@_) {
	return $self->{"FacMACname"};
    }

    $self->{"FacMACname"} = shift;

    return;
}

sub NetAddr {
    my $self = shift;

    if (!@_) {
	return $self->{"NetAddr"};
    }

    $self->{"NetAddr"} = shift;

    return;
}

sub NetName {
    my $self = shift;

    if (!@_) {
	return $self->{"NetName"};
    }

    $self->{"NetName"} = shift;

    return;
}

#
# Fetch description
#
sub Desc {
    my $self = shift;
    my $Key = shift;

    if ($Descriptions->{$Key}->{'NoShow'}) {
	return;
    }

    return $Descriptions->{$Key}->{'Desc'};
}

#
# Decode
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    $self->Type($Fields[3]);
    $self->HostAddr($Fields[4]);
    $self->HostName($Fields[5]);
    $self->NetAddr($Fields[6]);
    $self->NetName($Fields[7]);
    $self->MACaddr($Fields[8]);
    $self->MACname($Fields[9]);
    $self->FacMACaddr($Fields[10]);
    $self->FacMACname($Fields[11]);
}

1;
