/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

/*
 * Product Data functions
 */

#include "defs.h"
#include "proddata.h"

/*
 * Parse a Product Data string and return a namelist of values.
 * String looks like:
 *	PN:SunLAMP AN:S19130 SN:112M20E2 ES:NK20042023
 */
extern ProdData_t *ProdDataParse(String)
     char		       *String;
{
    int				Argc;
    char		      **Argv;
    ProdData_t		       *List = NULL;
    ProdData_t		       *Last = NULL;
    ProdData_t		       *New;
    register char	       *cp;
    register int		i;

    SImsg(SIM_DBG, "ProdDataParse: <%s>", String);

    Argc = StrToArgv(String, " ", &Argv, NULL, 0);
    if (Argc < 1) {
	SImsg(SIM_DBG, "ProdDataParse: <%s> No parts found.", String);
	return (ProdData_t *) NULL;
    }
    SImsg(SIM_DBG, "ProdDataParse: <%s> Parsed %d entries", String, Argc);

    for (i = 0; i < Argc; ++i) {
	New = (ProdData_t *) xcalloc(1, sizeof(ProdData_t));
	New->Key = Argv[i];
	if (!New->Key)
	    continue;
	if (cp = strchr(New->Key, ':')) {
	    *cp = CNULL;
	    New->Value = cp+1;
	}

	if (!List) {
	    List = Last = New;
	} else {
	    Last->Next = New;
	    Last = New;
	}
    }

    return List;
}

/*
 * Find ProdData entry with Key in List
 */
extern ProdData_t *ProdDataFind(List, Key)
     ProdData_t		       *List;
     char		       *Key;
{
    ProdData_t		       *pd;

    for (pd = List; List; List = List->Next) {
	if (EQ(Key, pd->Key))
	    return pd;
    }

    return (ProdData_t *) NULL;
}

