/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.2 $";
#endif

#include "defs.h"
#include "dmi.h"

/*
 * Decode DMI OEM Info (DMI_STRUCT_OEM)
 */
extern DevInfo_t *DmiDecodeOem(Hdr, Data, Dmi, Query)
     DmiHeader_t	       *Hdr;
     void		       *Data;
     Dmi_t		       *Dmi;
     DmiQuery_t		       *Query;
{
    DevInfo_t		       *DevInfo = NULL;
    DevDesc_t		      **lp;
    DmiStructOem_t	       *Oem;
    char		       *cp;
    register  int		i;

    Oem = (DmiStructOem_t *) Data;

    SImsg(SIM_DBG, 
	  "DMI OEM: Handle=0x%04X Count=%d",
	  Hdr->Handle, Oem->Count);
    SImsg(SIM_DBG, 
	  "DMI OEM:\tsizeof(DmiStructOem_t)=%d (0x%X) Hdr->Length=%d (0x%X)",
	  sizeof(DmiStructOem_t), sizeof(DmiStructOem_t), 
	  Hdr->Length, Hdr->Length);

    /*
     * If this is a specific query, then set the values now and return
     */
    if (Query && Query->Type == Hdr->Type) {
	/* Return nothing for now */
	return DevInfo;
    }

    /*
     * Just display for debug purposes until we know what to do with this data
     */
    for (i = 0; i < Oem->Count; ++i) {
	if (cp = DmiString(Hdr, i+1))
	    SImsg(SIM_DBG, "DMI OEM: String[%d]=<%s>", i+1, cp);
    }

#if 0
    DevInfo = NewDevInfo(NULL);
    DevInfo->Type = DT_GENERIC;
    lp = &(DevInfo->DescList);
#endif

    return DevInfo;
}
