#
# $Id: uiData.pm,v 1.3 2002/03/09 01:07:17 mcooper Exp $
#
# UI Data general functions
#

package uiData;

require 5.003;

require Exporter;

use mcDebug;
use uiMisc;
use uiGlobals;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   DataGetWidget
		  );
}

#
# Get the current data widget based on the class of $Path
#
sub DataGetWidget {
    my $Path = shift;

    my @Parts = split($PathSep, $Path);
    my $Class = uiClass::ClassGet($Parts[0]);
    if (!$Class) {
	Debug("DataGetWidget: Cannot determine data widget from <%s>", $Path);
	return;
    }
    if (!$Class->{Widget}) {
	Debug("DataGetWidget: Class <%s> has no widget defined.",
	      $Class->{Name});
	return;
    }

    return $Class->{Widget};
}

1;
