/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

/*
 * Permission functions
 */
#include <stdio.h>
#include <pwd.h>
#include <grp.h>
#include <sys/types.h>
#include "defs.h"

/*
 * Set permisions of Path
 */
extern int SetPerms(Path, Owner, Group, Mode)
     char		       *Path;
     char		       *Owner;
     char		       *Group;
     mode_t			Mode;
{
    struct passwd	       *Pwd;
    struct group	       *Grp;
    uid_t			Uid = -1;
    gid_t			Gid = -1;

    if (Owner) {
	if (!(Pwd = getpwnam(Owner))) {
	    Error("%s: Is not a valid username: %s", Owner, SYSERR);
	    return -1;
	}
	Uid = Pwd->pw_uid;
    }

    if (Group) {
	if (!(Grp = getgrnam(Group))) {
	    Error("%s: Is not a valid group name: %s", Group, SYSERR);
	    return -1;
	}
	Gid = Grp->gr_gid;
    }

    if (Uid >= 0 || Gid >= 0)
	if (chown(Path, Uid, Gid) < 0) {
	    Error("%s: Chown(%d, %d) failed: %s", 
		  Path, Pwd->pw_uid, Grp->gr_gid, SYSERR);
	    return -1;
	}

    if (chmod(Path, Mode) < 0) {
	Error("%s: Chmod %o failed: %s", Path, Mode, SYSERR);
	return -1;
    }

    return 0;
}

